"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const graphql_tag_1 = __importDefault(require("graphql-tag"));
exports.CHECK_PARTIAL_SCHEMA = graphql_tag_1.default `
  mutation CheckPartialSchema(
    $id: ID!
    $graphVariant: String!
    $implementingServiceName: String!
    $partialSchema: PartialSchemaInput!
  ) {
    service(id: $id) {
      validatePartialSchemaOfImplementingServiceAgainstGraph(
        graphVariant: $graphVariant
        implementingServiceName: $implementingServiceName
        partialSchema: $partialSchema
      ) {
        compositionValidationDetails {
          schemaHash
        }
        graphCompositionID
        errors {
          message
        }
      }
    }
  }
`;
//# sourceMappingURL=checkPartialSchema.js.map