"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.useI18N = void 0;

var _ = require("..");

var _locale = _interopRequireDefault(require("../../locale"));

var useI18N = function useI18N(name) {
  var prefix = (0, _.camelize)(name) + '.';
  return function (path) {
    var message = (0, _.get)(_locale["default"].messages(), prefix + path) || (0, _.get)(_locale["default"].messages(), path);

    for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      args[_key - 1] = arguments[_key];
    }

    return typeof message === 'function' ? message.apply(void 0, args) : message;
  };
};

exports.useI18N = useI18N;